# bzapi
Definitions for Boltzbit's product API's

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import bzapi
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import bzapi
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import bzapi
from bzapi.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://flow.boltzbit.com/bz-api
# See configuration.py for a list of all supported configuration parameters.
configuration = bzapi.Configuration(
    host = "https://flow.boltzbit.com/bz-api"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

# Configure Bearer authorization (JWT): BearerAuth
configuration = bzapi.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with bzapi.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = bzapi.DefaultApi(api_client)
    chat = bzapi.Chat() # Chat | 

    try:
        # Chat query
        api_response = api_instance.v2_chat_query_post(chat)
        print("The response of DefaultApi->v2_chat_query_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->v2_chat_query_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://flow.boltzbit.com/bz-api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**v2_chat_query_post**](docs/DefaultApi.md#v2_chat_query_post) | **POST** /v2/chat-query | Chat query
*DefaultApi* | [**v2_chat_query_streamed_post**](docs/DefaultApi.md#v2_chat_query_streamed_post) | **POST** /v2/chat-query-streamed | Streamed chat query
*DefaultApi* | [**v2_data_extraction_post**](docs/DefaultApi.md#v2_data_extraction_post) | **POST** /v2/data-extraction | Data extraction
*DefaultApi* | [**v2_databases_database_id_delete**](docs/DefaultApi.md#v2_databases_database_id_delete) | **DELETE** /v2/databases/{databaseId} | Delete a database
*DefaultApi* | [**v2_databases_database_id_get**](docs/DefaultApi.md#v2_databases_database_id_get) | **GET** /v2/databases/{databaseId} | Get a database
*DefaultApi* | [**v2_databases_database_id_put**](docs/DefaultApi.md#v2_databases_database_id_put) | **PUT** /v2/databases/{databaseId} | Update a database
*DefaultApi* | [**v2_databases_database_id_records_list_post**](docs/DefaultApi.md#v2_databases_database_id_records_list_post) | **POST** /v2/databases/{databaseId}/records/list | List database records
*DefaultApi* | [**v2_databases_database_id_records_post**](docs/DefaultApi.md#v2_databases_database_id_records_post) | **POST** /v2/databases/{databaseId}/records | Create a database record
*DefaultApi* | [**v2_databases_database_id_records_record_id_delete**](docs/DefaultApi.md#v2_databases_database_id_records_record_id_delete) | **DELETE** /v2/databases/{databaseId}/records/{recordId} | delete the database record
*DefaultApi* | [**v2_databases_database_id_records_record_id_get**](docs/DefaultApi.md#v2_databases_database_id_records_record_id_get) | **GET** /v2/databases/{databaseId}/records/{recordId} | get the database record
*DefaultApi* | [**v2_databases_database_id_records_record_id_put**](docs/DefaultApi.md#v2_databases_database_id_records_record_id_put) | **PUT** /v2/databases/{databaseId}/records/{recordId} | Update a datatbase record
*DefaultApi* | [**v2_databases_database_id_run_analytics_post**](docs/DefaultApi.md#v2_databases_database_id_run_analytics_post) | **POST** /v2/databases/{databaseId}/run-analytics | Execute natural language command on a database
*DefaultApi* | [**v2_databases_post**](docs/DefaultApi.md#v2_databases_post) | **POST** /v2/databases | Create databases
*DefaultApi* | [**v2_documents_bulk_upload_post**](docs/DefaultApi.md#v2_documents_bulk_upload_post) | **POST** /v2/documents/bulk-upload | Bulk upload documents
*DefaultApi* | [**v2_documents_document_id_delete**](docs/DefaultApi.md#v2_documents_document_id_delete) | **DELETE** /v2/documents/{documentId} | Delete a document
*DefaultApi* | [**v2_documents_document_id_get**](docs/DefaultApi.md#v2_documents_document_id_get) | **GET** /v2/documents/{documentId} | Get a document
*DefaultApi* | [**v2_documents_list_get**](docs/DefaultApi.md#v2_documents_list_get) | **GET** /v2/documents/list | List all documents


## Documentation For Models

 - [Box](docs/Box.md)
 - [Chat](docs/Chat.md)
 - [ChatBlockReference](docs/ChatBlockReference.md)
 - [ChatConversationBlock](docs/ChatConversationBlock.md)
 - [DataExtraction](docs/DataExtraction.md)
 - [DataExtractionRequest](docs/DataExtractionRequest.md)
 - [Database](docs/Database.md)
 - [DatabaseAnalyticsRequest](docs/DatabaseAnalyticsRequest.md)
 - [DatabaseAnalyticsResponse](docs/DatabaseAnalyticsResponse.md)
 - [DatabaseConnection](docs/DatabaseConnection.md)
 - [DatabaseRecord](docs/DatabaseRecord.md)
 - [DatabaseRecordFieldsValue](docs/DatabaseRecordFieldsValue.md)
 - [DatabaseSourceTable](docs/DatabaseSourceTable.md)
 - [DatabaseTableColumnSpec](docs/DatabaseTableColumnSpec.md)
 - [Document](docs/Document.md)
 - [Error](docs/Error.md)
 - [FileReference](docs/FileReference.md)
 - [ListDatabaseRecordsRequest](docs/ListDatabaseRecordsRequest.md)
 - [SigmaFilterParameters](docs/SigmaFilterParameters.md)
 - [SigmaSortParameters](docs/SigmaSortParameters.md)
 - [Source](docs/Source.md)
 - [Span](docs/Span.md)
 - [V2DatabasesDatabaseIdRecordsListPost200Response](docs/V2DatabasesDatabaseIdRecordsListPost200Response.md)
 - [WebReference](docs/WebReference.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-KEY
- **Location**: HTTP header

<a id="BearerAuth"></a>
### BearerAuth

- **Type**: Bearer authentication (JWT)


## Author




