# coding: utf-8

"""
    Boltzbit API

    Definitions for Boltzbit's product API's

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from bzapi.models.file_reference import FileReference
from bzapi.models.span import Span
from bzapi.models.web_reference import WebReference
from typing import Optional, Set
from typing_extensions import Self

class ChatBlockReference(BaseModel):
    """
    ChatBlockReference
    """ # noqa: E501
    span: Optional[Span] = None
    file_reference: Optional[FileReference] = Field(default=None, alias="fileReference")
    web_reference: Optional[WebReference] = Field(default=None, alias="webReference")
    __properties: ClassVar[List[str]] = ["span", "fileReference", "webReference"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChatBlockReference from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of span
        if self.span:
            _dict['span'] = self.span.to_dict()
        # override the default output from pydantic by calling `to_dict()` of file_reference
        if self.file_reference:
            _dict['fileReference'] = self.file_reference.to_dict()
        # override the default output from pydantic by calling `to_dict()` of web_reference
        if self.web_reference:
            _dict['webReference'] = self.web_reference.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChatBlockReference from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "span": Span.from_dict(obj["span"]) if obj.get("span") is not None else None,
            "fileReference": FileReference.from_dict(obj["fileReference"]) if obj.get("fileReference") is not None else None,
            "webReference": WebReference.from_dict(obj["webReference"]) if obj.get("webReference") is not None else None
        })
        return _obj


