# coding: utf-8

"""
    Boltzbit API

    Definitions for Boltzbit's product API's

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from bzapi.models.database_connection import DatabaseConnection
from bzapi.models.database_source_table import DatabaseSourceTable
from typing import Optional, Set
from typing_extensions import Self

class Database(BaseModel):
    """
    Database
    """ # noqa: E501
    id: Optional[StrictStr] = None
    db_connection: Optional[DatabaseConnection] = Field(default=None, alias="dbConnection")
    name: StrictStr
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    created_by: Optional[StrictStr] = Field(default=None, alias="createdBy")
    source_tables: List[DatabaseSourceTable] = Field(alias="sourceTables")
    __properties: ClassVar[List[str]] = ["id", "dbConnection", "name", "createdAt", "createdBy", "sourceTables"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Database from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of db_connection
        if self.db_connection:
            _dict['dbConnection'] = self.db_connection.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in source_tables (list)
        _items = []
        if self.source_tables:
            for _item_source_tables in self.source_tables:
                if _item_source_tables:
                    _items.append(_item_source_tables.to_dict())
            _dict['sourceTables'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Database from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "dbConnection": DatabaseConnection.from_dict(obj["dbConnection"]) if obj.get("dbConnection") is not None else None,
            "name": obj.get("name"),
            "createdAt": obj.get("createdAt"),
            "createdBy": obj.get("createdBy"),
            "sourceTables": [DatabaseSourceTable.from_dict(_item) for _item in obj["sourceTables"]] if obj.get("sourceTables") is not None else None
        })
        return _obj


