# coding: utf-8

"""
    Boltzbit API

    Definitions for Boltzbit's product API's

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from bzapi.models.database_table_column_spec import DatabaseTableColumnSpec
from typing import Optional, Set
from typing_extensions import Self

class DatabaseSourceTable(BaseModel):
    """
    DatabaseSourceTable
    """ # noqa: E501
    is_archived: Optional[StrictBool] = Field(default=False, alias="isArchived")
    db_table_name: Optional[StrictStr] = Field(default=None, alias="dbTableName")
    display_name: StrictStr = Field(alias="displayName")
    columns: List[DatabaseTableColumnSpec]
    __properties: ClassVar[List[str]] = ["isArchived", "dbTableName", "displayName", "columns"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatabaseSourceTable from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in columns (list)
        _items = []
        if self.columns:
            for _item_columns in self.columns:
                if _item_columns:
                    _items.append(_item_columns.to_dict())
            _dict['columns'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatabaseSourceTable from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "isArchived": obj.get("isArchived") if obj.get("isArchived") is not None else False,
            "dbTableName": obj.get("dbTableName"),
            "displayName": obj.get("displayName"),
            "columns": [DatabaseTableColumnSpec.from_dict(_item) for _item in obj["columns"]] if obj.get("columns") is not None else None
        })
        return _obj


