# coding: utf-8

"""
    Boltzbit API

    Definitions for Boltzbit's product API's

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from bzapi.models.sigma_filter_parameters import SigmaFilterParameters
from bzapi.models.sigma_sort_parameters import SigmaSortParameters
from typing import Optional, Set
from typing_extensions import Self

class ListDatabaseRecordsRequest(BaseModel):
    """
    ListDatabaseRecordsRequest
    """ # noqa: E501
    table_name: Optional[StrictStr] = Field(default=None, alias="tableName")
    sort: Optional[SigmaSortParameters] = None
    filters: Optional[List[SigmaFilterParameters]] = None
    __properties: ClassVar[List[str]] = ["tableName", "sort", "filters"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListDatabaseRecordsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sort
        if self.sort:
            _dict['sort'] = self.sort.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in filters (list)
        _items = []
        if self.filters:
            for _item_filters in self.filters:
                if _item_filters:
                    _items.append(_item_filters.to_dict())
            _dict['filters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListDatabaseRecordsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tableName": obj.get("tableName"),
            "sort": SigmaSortParameters.from_dict(obj["sort"]) if obj.get("sort") is not None else None,
            "filters": [SigmaFilterParameters.from_dict(_item) for _item in obj["filters"]] if obj.get("filters") is not None else None
        })
        return _obj


