# coding: utf-8

"""
    Boltzbit API

    Definitions for Boltzbit's product API's

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SigmaFilterParameters(BaseModel):
    """
    SigmaFilterParameters
    """ # noqa: E501
    db_name: StrictStr = Field(alias="dbName")
    like_values: List[Any] = Field(alias="likeValues")
    equal_to_values: List[Any] = Field(alias="equalToValues")
    greater_than_value: Optional[Any] = Field(alias="greaterThanValue")
    less_than_value: Optional[Any] = Field(alias="lessThanValue")
    __properties: ClassVar[List[str]] = ["dbName", "likeValues", "equalToValues", "greaterThanValue", "lessThanValue"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SigmaFilterParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if greater_than_value (nullable) is None
        # and model_fields_set contains the field
        if self.greater_than_value is None and "greater_than_value" in self.model_fields_set:
            _dict['greaterThanValue'] = None

        # set to None if less_than_value (nullable) is None
        # and model_fields_set contains the field
        if self.less_than_value is None and "less_than_value" in self.model_fields_set:
            _dict['lessThanValue'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SigmaFilterParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dbName": obj.get("dbName"),
            "likeValues": obj.get("likeValues"),
            "equalToValues": obj.get("equalToValues"),
            "greaterThanValue": obj.get("greaterThanValue"),
            "lessThanValue": obj.get("lessThanValue")
        })
        return _obj


